----------------------- Version 3.02 ---------------------------
NEW FEATURE:  Added 0.25x scroll speed
CHANGE:  Reorganized options on Player Options screen
NEW FEATURE:  New modifier: Acceleration-Land
NEW FEATURE:  New modifier: Acceleration-Expand
NEW FEATURE:  New modifier: Acceleration-Boomerang
CHANGE:  Tweaked Acceleration-Wave for more of a challenge
CHANGE:  Changed format  NoteSkin tap graphic format.  Existing NoteSkins will 
	need to update the tap graphic.
NEW FEATURE:  New Edit menus with ability to delete Notes patterns and new 
	options	for importing existing patterns into a new Notes pattern.
NEW FEATURE:  Jukebox mode.  Like demonstration, but plays entire songs 
	and loops.
NEW FEATURE:  Print screen to save screenshot.  Saved in "Screenshots"
	as "screenshotXXXX.bmp".
CHANGE:  Reorganization of options screens.
NEW FEATURE: Option for user-selectable extra stage.
CHANGE:  Documentation now in HTML format.
CHANGE:  Overhauled NoteSkin format.  See README-FIRST.html for details.
BUG FIX:  Super-shuffle fixed (now doesn't add extra notes).
NEW FEATURE:  Added WIDE transform (changes notes on beats to jumps).
NEW FEATURE:  Added BIG transform (strategically inserts 8ths).
NEW FEATURE:  Added QUICK transform (strategically inserts 16ths).
NEW FEATURE:  Added SKIPPY transform.
NEW FEATURE:  Added HALLWAY, DISTANCE and INCOMING perspectives.
NEW FEATURE:  Added tipsy, split, alternate, blind.
BUG FIX:  Fixed song seeking in editor at non 1x music rates
NEW FEATURE:  More complete controls for BackgroundChanges in editor
NEW FEATURE:  Shift+P in editor for "play current beat until end"
NEW FEATURE:  Select between Normal and Difficult in course modes
CHANGE:  Nonstop and Oni scoring and combo counter behave exactly like DDREX
CHANGE:  HoldNote life snaps to full when button is pressed (instead of 
	refilling slowly) ala DDR
NEW FEATURE:  Toggle for Autogen of missing steps
NEW FEATURE:  Toggle for Autogen of group Nonstop and Endless Courses
OPTIMIZATION:  Turned off compression when exporting packages, which makes
	exporting significantly faster.
NEW FEATURE:  Convert a theme from the 3.0 naming convention to the 4.0 
	naming convention using "Analyze Theme" in smpackage.exe.
NEW FEATURE:  Check for redundant and possibly mis-named theme elements using
	"Analyze Theme" in smpackage.exe.
NEW FEATURE:  Set default player and song options in stepmania.ini using 
	DefaultModifiers.
NEW FEATURE:  Courses can be organized into group folders.  See 
	README-FIRST.html for details.
NEW FEATURE:  Switch current theme from TitleMenu with L,L,L,R,R,R,L,R.
NEW FEATURE:  Switch current announcer from TitleMenu with L,L,R,R,L,R,L,R.
NEW FEATURE:  New parameters for background changes: rate, fade old, loop, 
	rewind.
CHANGE:  Background playback speed scaled by song rate, so movies stay in 
	sync (although syncing isn't very accurate at some song rates).
NEW FEATURE:  Automatic mapping of joysticks.
NEW FEATURE:  #DISPLAYBPM tag for SM and DWI files.
NEW FEATURE:  Korean characters in KSF files are converted correctly
NEW FEATURE:  Music rates .3x and .5x
NEW FEATURE:  Pump half-doubles
NEW FEATURE:  Song lyrics
BUG FIX:  Sort songs starting with a decimal point in the NUM folder
NEW FEATURE:  Courses can be made more difficult; use the same codes as selecting a song
NEW FEATURE:  Beginner difficulty
NEW FEATURE:  Music wheel can be set to have sections for ABC only
NEW FEATURE:  Note skins can now be selected per-player on the player options screen
CHANGE:  "Challenge" steps are good enough for an extra stage.
NEW FEATURE:  Turn off autofail by default for beginner/easy; turn off failure
	completely for beginner first stage.
BUG FIX:  Check the alternative song folders for extra stage courses.
BUG FIX:  Don't make the gain-life song between Oni courses if we didn't
	actually gain any life.
NEW FEATURE:  Added long and marathon balloons.
Try not to repeat songs in random courses.
CHANGE:  Little removes HoldNotes that don't start on a beat.
NEW FEATURE:  Allow showing dance points instead of percentage in oni.
NEW FEATURE:  Write #BEGINNER, #FILE and #CDTITLE to DWIs.  Implement
	<2468> jumps.
NEW FEATURE:  DWI reading: Implement `192nds', <46> jumps, and <4!46!6> hold
	jumps. <4006> (containing 0s) is still treated as 192nds, for
	backwards compatibility.
NEW FEATURE:  Guess titles from directory names if #TITLE is missing.
NEW FEATURE:  Remove song length limits.
NEW FEATURE:  Added lyrics support.
NEW FEATURE:  Song options screen is optional.
CHANGE:  Jumps are now graded on the score that completes the row, not the
	minimum score of the row.
NEW FEATURE:  Added a theme metric editor.
NEW FEATURE:  How To Play screen.
NEW FEATURE:  Maximum number of random backgrounds is configurable.
CHANGE:  Changed 1280x1024 to 1280x960.
CHANGE:  Removed limit of 1200 songs in the music screen.
NEW FEATURE:  Added banner caching.
CHANGE:  Changed nonstop scoring: all nonstop courses sum to 100mil points.
NEW FEATURE:  Add option screen scrolling.
NEW FEATURE:  Add steps selection to the player options menu.
NEW FEATURE:  Add new music wheel sorts.
NEW FEATURE:  Handle group banners in the parent dir.
NEW FEATURE:  Return to the select course screen after name entry in event mode.
NEW FEATURE:  Allow configuring bit depth for movies.
NEW FEATURE:  "Courses only" option for marvelous judgement.
CHANGE:  Challenge notes no longer make a song red.
NEW FEATURE:  Setting a background brightness of 0 disables backgrounds
	completely.
NEW FEATURE:  SMPackage: Allow disabling comments
NEW FEATURE:  SMPackage: Uninstall packages before installing new ones
NEW FEATURE:  Never use files listed in (otherwise unused) #DISPLAYTITLE
	and #DISPLAYARTIST DWI fields as song banners, nor  images
	containing "-char".
NEW FEATURE:  Added progressive lifebar motion.
NEW FEATURE:  Added random caprice courses.
NEW FEATURE:  Added JUSTICE.
NEW FEATURE:  Added generated "stats.html"
NEW FEATURE:  Added beginner helper
NEW FEATURE:  Added dancing character to the how to play screen
NEW FEATURE:  Added announcers "gameplay oni fail", "gameplay oni fail halfway" and "gameplay combo overflow"
NEW FEATURE:  Added FFMpeg-based movie decoding.
NEW FEATURE:  Added left+right+start to move back in options menus when in arcade-style navigation
CHANGE:  Require a combo before regaining life after bottoming out
NEW FEATURE:  Added profiles support
CHANGE:  Removed IgnoreJoyAxes; no longer needed
NEW FEATURE:  Added title menu switch game code (LRLLRRLR)
CHANGE:  Improved DWI/SM file error recovery.
NEW FEATURE:  Support for up to 6 joysticks and 32 buttons per joystick.
NEW FEATURE:  Screen centering adjustment.
NEW FEATURE:  Added input test screen.
NEW FEATURE:  Added option for silent attract sequence.
NEW FEATURE:  Name entry announcer.
CHANGE:  Don't show the danger animation if failure is disabled.
CHANGE:  Only lock and fail in fail-end-of-song if both players are failing
	at the same time.
CHANGE:  Fail-end-of-song fails after the current song in course play.
NEW FEATURE:  Editor: Added alt-F11, F12 to change offset in 1ms increments
NEW FEATURE:  Editor: Added F5/F6 to switch steps
NEW FEATURE:  Editor: Added Alt-F7/F8 for finer BPM adjustment
CHANGE:  Editor: Don't clear area before recording
NEW FEATURE:  Editor: Added subtitle and song credit editing

----------------------- Version 3.01 ---------------------------
CHANGE:  Simplified NoteSkin tap graphic format.  Old NoteSkins will need to 
	update the tap graphic.
NEW FEATURE:  AutoSync status now shown during gameplay with icon
NEW FEATURE:  Added autogen icon to select music
NEW FEATURE:  Toggle for easter eggs in Machine Options
NEW FEATURE:  Marvelous step timing togglable in Machine Options
NEW FEATURE:  Grade AAAA (all marvelous)
CHANGE:  Only show ScreenHowToPlay if at least one player chose easy
NEW FEATURE: New High Score screen
NEW FEATURE: Full "attract" sequence
NEW FEATURE: .SM files can now contain UTF-8 text.
NEW FEATURE: New alignment tags for bitmap fonts.
NEW FEATURE: Bitmap fonts now support full Unicode mapping.
CHANGE:  Internal precision increased; 32nd notes are no longer rounded.
NEW FEATURE: Added "RANDOM" to music select.
CHANGE:  Loading optimizations.
NEW FEATURE: Caution and group select screens can now be disabled.
CHANGE:  Input, renderer and sound subsystems rewritten.
BUG FIX: Music scrollbar fixed.
CHANGE:  Faster music wheel sort changing and scrolling.
CHANGE:  Ignore invalid KSFs.
NEW FEATURE: DWI SAMPLESTART and SAMPLELENGTH in milliseconds is now
         supported.
CHANGE:  Courses are no longer limited to 300 songs.
CHANGE:  The radar display is improved.
NEW FEATURE: The Caution and Select Group screens can now be disabled.
CHANGE:  OKs now count as a step in score calculation.
CHANGE:  Maximum number of hold steps removed.
BUG FIX:  Fixed "autogen doesn't generate patterns for all difficulties for
         some songs"
BUG FIX:  Fixed incorrect "show" value in "show!hold" being written in DWIs
BUG FIX:  Fixed "song ends early after adding an edit then playing"
BUG FIX:  Oni score now displays a % sign after the score.
BUG FIX:  An E Grade is now properly awarded to a player who fails a song
          when two players are playing.
BUG FIX:  Modifiers applied to a single song in an .CRS file are no longer 
          applied to the following songs.

------------------------CVS after 3.00 beta 6rc2----------------
BUG FIX:  Crash handler works better in full screen.
BUG FIX:  Crash handler restarts correctly.
BUG FIX:  Fixed choosing song filenames when saving.
BUG FIX:  Fix Endless crash when a song folder has over 99 minutes of songs.
BUG FIX:  Can no longer keep a hold lit if it's missed completely.
BUG FIX:  No NG or NG penalty in Oni if a hold is missed completely.
CHANGE:  Name changed to "beta 7" to avoid confusion with the numerous beta 6
	release candidates.
BUG FIX:  Courses now work with AdditionalSongFolders and DWIPath.
BUG FIX:  Fixed writing solo patterns to DWI file.
CHANGE:  Group names: Pump It Up (PiU), ParaParaParadise (PPP), Dancing Stage 
	(DS) are now shortened.
BUG FIX:  Statistics for singles no longer show up under doubles
CHANGE:  Added separate difficulty icons for smaniac, challenge, and battle.
CHANGE:  Faster transition between songs in Oni.
CHANGE:  Default setting for "Ignore Joy Axes" is now ON.
BUG FIX:  Para demonstation no longer crashes.
BUG FIX:  DWI reader now reads fractional BPM and FREEZE index values (e.g. 
	Alya Part 2).
BUG FIX:  Fixed ez2 real style spacing
CHANGE:  #SAMPLESTART tag now written in DWI files
CHANGE:  Editor now snaps while recording
OPTIMIZATION:  More efficient texture memory usage
BUG FIX:  Text entry now supports puntuation while holding Shift
CHANGE:  AutoGen now only generated dance->pump and pump->dance to cut
	down on initial load time
CHANGE:  Texure cache disabled because of performance problems on low memory 
	systems.  If you have >= 128MB memory, you may want re-enable it by 
	setting UnloadTextureDelaySeconds=1800.
BUG FIX:  Fixed super shuffle generating impossible HoldNote patterns

------------------------CVS after 3.00 beta 6----------------
CHANGE:  Missing a jump with the Oni life meter now subtracts only 1 life.
CHANGE:  Judge difficulty strictness increased slightly.
CHANGE:  Initial sort order now sorts by meter of Easy notes, ala MAX.
BUG FIX:  DWI music sample info now read correctly - again.
NEW FEATURE:  Precise adjustment of timing window for each grade via the
	stepmania.ini file (see JudgeWindowPerfectPercent, JudgeWindowGreatPercent,
	etc).
OPTIMIZATION:  Better texture caching algorithm for faster loading of menus.
NEW FEATURE: Ez2SelectStyle ScrollingList Contents now Metric Configurable.
NEW FEATURE: PPP and PUMP use Ez2SelectStyle Menus to become more
	arcade-accurate.
NEW FEATURE: Ez2SelectStyle Menu Background Animations Metric Configurable
NEW FEATURE: ParaParaParadise Support
NEW FEATURE:  Added transliteration support for song titles, subtitles & artist
	names.  Tags are #TITLETRANSLIT, #SUBTITLETRANSLIT & #ARTISTTRANSLIT
	respectively.  The transliterations of the title and subtitle are used when 
	sorting	and grouping songs, so non-latin songs can be placed correctly
NEW FEATURE:  DWI tree loading via "DWIPath".
NEW FEATURE:  Pump couples support.
BUG FIX:  Editor no longer crashes if you try to drag a hold note up
	before beat 0.
CHANGE:  Hold head now drawn in place tap note graphic when a Hold starts
	on the same row.
CHANGE:  Added bright ghost flash on hold note score of OK.
CHANGE:  Font format new easier to export for font creators.  See README 
	for details.
NEW FEATURE:  Option Icons.
NEW FEATURE:  Best sort now shows only top 30 songs.
NEW FEATURE:  Option codes on the Select Music and Select Course screens
	Codes are defined in the metrics.ini file and thus can be edited and
	changed per-theme.  The "Dedicated Menu Buttons" option does not 
	have to be enabled to use codes. 
NEW FEATURE:  SuperShuffle shuffles each individual note row.  This 
	makes for a completely different note pattern every time.
CHANGE:  Boost is now a separate option and can be combined with other 
	effects.
NEW FEATURE:  New Effects: Backwards and Tornado.
NEW FEATURE:  More informative crash dialog.
BUG FIX:  Fix editor saving files with an extra space at the end
	of the filename.
NEW FEATURE:  #SELECTABLE:YES, NO, ROULETTE.
NEW FEATURE:  Added assist tick toggle to editor.
NEW FEATURE:  Added editing of text fields to editor.
CHANGE:  Improved the appearance of hidden/sudden.
CHANGE:  After changing sort to "BEST", focus will be changed to the 
	the most-played song.
CHANGE:  Texture Hints have been removed in favor of smarter, automatic
	texture format chooser.
CHANGE:  New Nullsoft NSIS installer.
CHANGE:  NG no longer breaks combo.
NEW FEATURE:  Hidden easter egg.  You have to be "perfect" to find it.
	And cheaters never prosper!
NEW FEATURE:  If a song is missing Notes of a certain NotesType, Notes of 
	the missing type will be generated from the existing types.  For 
	example, this will allow any pump song to be played in the dance
	game mode, and vice versa.
NEW FEATURE:  Package Exporter now can export Announcers, BGAnimations,
	Courses, NoteSkins, RandomMovies, Themes, and Visualizations.
NEW FEATURE:  Package Exporter now has two options: "Export As One", and 
	"Export As Individual".  Export As One will create a package of all
	selected items, and Export As Individual will create packages for each
	of the selected items.
CHANGE:  Renamed "Skins" folder to "NoteSkins" to avoid confusion with DWI 
	and KIU.
NEW FEATURE:  F6 during gameplay to toggle assist tick.
CHANGE:  While AutoPlay is ON, life will not change and score/dance points 
	will not accumulate.
NEW FEATURE:  Song list can handle any number of groups.
BUG FIX:  Fix joystick Y axis.
NEW FEATURE:  Add level 8 judge difficulty.
CHANGE:  While AutoPlay is on, life, score, and dance points will not 
	accumulate.
CHANGE:  DWI save support added to editor.
NEW FEATURE:  Editor can edit BackgroundChanges.  Use the 'B' key.
NEW FEATURE:  Delayed escape/back key is now optional.
CHANGE:  Slow-motion is now ~ instead of LShift.
BUG FIX:  Fix pump doubles offset.
NEW FEATURE:  Support for #DIFFICULTY in KSF.
CHANGE:  Allow starting without a keyboard or mouse.
NEW FEATURE:  Support for "artist - title - difficulty" titles in KSF.
BUG FIX:  Fix repeating announcer when you get a 100*n combo and break it
	at the 100*n+1st step.
BUG FIX:  When skipping the evaluation screen, stop spinning the grade
	so it can be seen during fade out.
NEW FEATURE:  Backspace and delete can be used (in addition to space) to
	remove key mappings.
NEW FEATURE:  The caution screen can be backed out of.
CHANGE:  A game that doesn't have any note skins installed is now invisible on 
	the Select Game screen.  This can be used to selectively disable a game.
CHANGE:  Graphics and sounds now more compressed more for a smaller download.
CHANGE:  The "Difficulty Banner" (displayed while dancing) is now a graphic
	that can be overwritten by themes.
CHANGE:  An invalid character in a DWI file is now a warning, not a Fatal Error.
BUG FIX:  Fixed "blinky arrows".
CHANGE:  Note Skin format has changed.  Now supports MAX-style holds.
OPTIMIZATION:  Improved font alignment.  Scaled fonts now appear less blurry.
BUG FIX:  Random Movies no longer upside down.
NEW FEATURE:  Extra stage top and bottom bars now reversed
NEW FEATURE:  Most graphical elements can be positioned per theme using 
    metrics.ini in the theme folder.  See the theme section of the readme for 
	more info.
BUG FIX:  Autoplay no longer misses the first step if it lies on beat 0.
NEW FEATURE:  Support for holds notes in KSF.
CHANGE:  KSF title discovery will use song foler name if KSF file contains 
	foreign characters.
BUG FIX:  Stepping before start of a note at beat 0 no longer results in a BAD.
BUG FIX:  Editor now works with dance-couple note patterns
BUG FIX:  Lead-in/lead-out time added to Play and Record in editor.
CHANGE:  Song specific Background Animations removed.  It will be replaced with
	a more powerful system soon.
CHANGE:  BGAnimations are now chose randomly from all animations rather than 
	from a specific group ("trance", "techno", etc).
NEW FEATURE:  "Show Danger" toggle in game options to enable/disable
	flashing danger message.
CHANGE:  "Event Mode" option renamed to "Unlimited Arcade Stages".
NEW FEATURE:  Graphic Option "MovieDecodeMS".  Controls how many milliseconds
	the program will sleep each frame to allow the movie background movie
	decoding thread to catch up.  Increase this number if movies are
	dropping frames.  Decrease this number to decrease the priority of
	movie decoding.
CHANGE:  "SongFolders" renamed to "AdditionalSongFolders".
BUG FIX:  AdditionalSongFolers no longer creates duplicate entries on program
	load.
CHANGE:  RandomMovies now start playing on the note and stop playing on the 
	last note.
CHANGE:  Background Movies now start playing at beat 0, and the movie should
	synchronize with the notes (BMR's Colors, etc).
OPTIMIZATION:  New deferred rendering architecture uses more CPU in order to
	create more efficient operations for the graphics card.
BUG FIX:  Select Group no longer crashes with > 15 groups.
CHANGE:  Last edited song is selected upon entering Edit Menu.
BUG FIX:  "Indirect BPM changes" (track 08) work again.  This was causing 
	"0 BPM" segments to be added to songs like MAX300.
BUG FIX:  Fixed life meter stream alignment (I hope!)
NEW FEATURE:  Graphic option "UseBGIfNoBanner" causes the song background to be 
	used if the banner is missing.  Turning this option ON may results in
	short freezes when switching music on the SelectMusic screen.
BUG FIX:  Music no longer cuts off if notes end before music.
BUG FIX:  "100 Combo" no longer repeats if combo breaks on 100.
BUG FIX:  "Japanese driver in training sign" next to song title now only shown
	if song has notes with meter <= 2.
BUG FIX:  Sort order icon on Select Music screen now accurately displays the 
	sort.
BUG FIX:  "Best" sort now correctly sorts the songs in decending order by the
	number of times played.
CHANGE:  Music sort change can now be done with L+R+Start, or U,D,U,D (for 
	people with soft pads that find L+R+Start to be difficult)
BUG FIX:  Player2 can now navigate menus when playing Double.
BUG FIX:  Fixed glitches caused by timer expiring after selection was made.
BUG FIX:  Timer expiration while group is in focus will start roulette.
BUG FIX:  Timer expiration while in Roulette spinning now resets the timer to
	force a selection.
BUG FIX:  OnlyDedicatedMenuButtons option now correctly saves on exit.
BUG FIX:  Announcer now says "danger comments" at the appropriate time.
BUG FIX:  Song titles on the Select Group screen are now cropped.

------------------------CVS after 3.00 beta 5----------------
OPTIMIZATION:  Much faster song loading.
BUG FIX:  New hashing algorithm prevents multiple songs from hashing to the same 
     cache file.
BUG FIX:  "Select Group" screen now only displays songs and groups available in
     the current style (instead of all songs).
BUG FIX:  Opening a "(NEW)" sequence in Edit/Record/Synch mode with a style
     over 4 panels (such as dance-solo or ez2-single) now works.
BUG FIX:  Oni life meter finished.
NEW FEATURE:  Theme support.  See readme for more info.
BUG FIX:  Stop times now read correctly again in BMSs.
BUG FIX:  #SOLO steps in DWIs now read correctly.
OPTIMIZATION:  Startup time greatly reduced thanks to hiding the log window and
     SM parsing optimizations
CHANGE:  Display resolution and max texture size sliders re-enabled
NEW FEATURE:  Refresh rate slider
NEW FEATURE:  0.5x, 0.75x scroll speed
NEW FEATURE:  Song rates up to 1.5X
NEW FEATURE:  Effect Mini
CHANGE:  Now hold L&R while pressing start to change sort on Select Music
CHANGE:  Combo display now draws behind notes
BUG FIX:  Stage counter reset after fail (thanks Andy)
BUG FIX:  Roulette chooses from only last preferred group
BUG FIX:  Fail End of Song setting doesn't get stuck at end of song.
CHANGE:  Back button must now be held for 1/2 a second to prevent accidental presses.
BUG FIX:  No more slowdown when song background showing song background (I think).
BUG FIX:  Fixed clipping problems related to scroll speed
BUG FIX:  Hold notes no longer jitter at certain scroll speeds
NEW FEATURE:  During gameplay:  F8 = toggle AutoPlay
NEW FEATURE:  During gameplay:  F9 = decrease offset, F10 = increase offset, 
NEW FEATURE:  During gameplay:  F11 = decrease BPM of current segment, F12 = 
	 increase BPM of current segment.
NEW FEATURE:  After changing Offset or BPM during gameplay, I prompt will appear
	at the end of the stage or course asking if you want to save changes.
	Chosing cancel will revert to the pre-modified values.
CHANGE:  Life meters graphics are now part of the theme system
CHANGE:	 New Song Option:  Choose Oni life battery or normal life meter
BUG FIX:  Life Bar no-recover and sudden death options now work.
BUG FIX:  Select Difficulty arrow no longer messed up on early input
BUG FIX:  Fixed scoring inaccuracies in Oni
NEW FEATURE:  Endless, next to Oni Nonstop
BUG FIX:  Inaccurate earned Chaos radar values fixed
BUG FIX:  Score multiplier now based on note number and not current combo size.
	This change causes higher, but MAX2-accurate scores.
NEW FEATURE:  KSF file reading.  Just drop the KSF folders into a group folder.
NEW FEATURE:  Pump It Up support
NEW FEATURE:  Life Difficulty option - this option determines how much the life 
    meter changes when steps are judged.  This option corresponds to Difficulty in 
	DDR Arcade machines.
CHANGE:  Old difficulty option renamed to Judge Difficulty.
NEW FEATURE:  MenuInput option.  Setting this option to "USE ONLY DEDICATED MENU 
	BUTTONS" will allow the menus to be controlled only by the buttons mapped to
	MenuLeft, MenuRight, etc.  This is useful if you have a controller with 
	buttons that can be dedicated to controlling the menus (like a DDR arcade
	cabinet).  Also, using only dedicated menu buttons will allow you to enter
	codes at the Select Music screen using the dance panels.
NEW FEATURE:  Random background movies.  Put a bunch of movies in RandomMovies and
	change the BackgroundMode setting in Game Options to "RANDOM MOVIES".
CHANGE:  Made folders for DWI-style CDTitles and DWI-style Music.
BUG FIX:  Fixed more HoldNote drawing ugliness.
BUG FIX:  Hidden and Sudden now work with Reverse.
BUG FIX:  Group names are now correct when using the SongFolders option
BUG FIX:  No longer crashes in Select Group with > 15 groups
NEW FEATURE:  PlayerOptions and SongOptions displays on the Select Music screen.
BUG FIX:  Extra stage actually works!  Props to Bruno for all of his help with this.
	You can manually specify extra stage 1 and 2 by creating a .CRS files in the 
	group folder called extra1.crs and extra2.crs.  These courses must contain 
	exactly one valid song.  Don't forget to specify modifiers - see the CRS File 
	Format section in the readme for more information.  If a CRS file is not found
	or is invalid, the program will choose approprite Song/Notes/Options.
BUG FIX:  Browsing past a song that don't have notes for some Difficulties will not 
	change your preferred difficulty.
BUG FIX:  TurnMirror, TurnLeft, and TurnShuffle now work.  TurnRight does the same 
	thing is as TurnLeft temporarily.
NEW FEATURE:  Demonstration plays after sitting idle at title screen.
CHANGE:  Note Skins can now control both the tap tween colors and hold tween colors
	with the files "(ButtonName) Tap.colors" and "(ButtonName) Tap.colors".
CHANGE:  Tap colors now interpolated for smoother color animation.
CHANGE:  Tweaked Drunk for a more interesting effect.

------------------------Version 3.00 beta 4------------------
BUG FIX:  Fixed crash entering Config Joy/Key (duh!)
BUG FIX:  Smarter bannner/backgroung/cdtitle discovery
NEW FEATURE:  Supports reading CDTitles from the .\CDTitles folder (compatible 
     with DWI).  Song makers are not encouraged to use this feature and instead should
     put the CDTitle graphic in the song folder.  Having a separate CDTitles folder 
     breaks the principle that all files needed to play a song should reside in the 
     song folder.
BUG FIX:  Fixed "D3DCreateTextureFromFile" error.  This happend a lot on a Voodoo3 
     and Win98.
BUG FIX:  Fixed "Divide by 0"/"Access Violoation" when loading a song - I think.
OPTIMIZATION:  Faster loading at "Nth Stage" screen.

------------------------Version 3.00 beta 3------------------
BUG FIX:  Fixed crash BemaniRuler's "Connected"
BUG FIX:  #BPMCHANGE in DWI files now read fractional values (BemaniRuler's Naturally)
BUG FIX:  Dizzy works correctly again
BUG FIX:  Subtitle extraction now works for "Dub-I-Dub" and "SP-Trip Machine"
BUG FIX:  No longer crashes on Titles starting with '('
BUG FIX:  Earlier scrolling for songs that have early notes (BMR's A)
BUG FIX:  Inserted blank time for songs that have note right at end of song (AM-3P)
OPTIMIZATION:  Faster loading of gameplay screen
BUG FIX:  Sample music no longer studders on Select Music screen
BUG FIX:  "Shaky" artifacts no longer appear while holding a hold note
CHANGE:  Re-added support for movie visualizations (by popular demand).
NEW FEATURE:  Movie backgrounds.  Either specify with the "#MOVIEBACKGROUND" tag, 
     or the first movie file in the song directory will be used.  Works with
	 BemaniRuler's background movies.  Background movie will not play will not play 
	 if BackgroundMode is set to "OFF".
NEW FEATURE:  Song-specific animations.  Place all animations in a folder called 
     "BGAnimations" within the song folder.  See "13. The .SM file format" and 
     "14. Background Animations" in README-FIRST.txt for details.
CHANGE:  Appearance Options now available from Title Menu.  Here you can choose
     the announcer and note skin.

------------------------Version 3.00 beta 2------------------
BUG FIX:  Fixed crash when loading MAX2 files from ddrei.com
CHANGE:  "JudgeWindow" option name changed to "Difficulty"
CHANGE:  Initial difficulty made easier
BUG FIX:  Song loading now smarter about how it picks banners, backgrounds, 
     and CDTitles.  See readme "6. How StepMania Loads Songs" for details.
BUG FIX:  #BPMS in SM files now read fractional values
NEW FEATURE:  Background brightness (Game Options)
BUG FIX:  BemaniRuler songs (like Pulse) now loaded correctly
BUG FIX:  Stationary arrows don't press unless note is a hit
BUG FIX:  Size of combo text capped to a reasonable level
BUG FIX:  Song background now stretched correctly when used in a background animation
OPTIMIZATION:  Reduced lag while starting music sample (Select Music screen)
NEW FEATURE:  Menu Timer - accessable from Game Options
BUG FIX:  Changes saved in editor now show up immediately (instead of after restart)

------------------------Version 3.00 beta 1------------------
NEW FEATURE:  Roulette
NEW FEATURE:  AutoPlay (selectable from Game Options screen)
NEW FEATURE:  Read Delight BMS 0.5 (hold notes, freezes, and new BPM changes supported)
NEW FEATURE:  Editor - edit, record, playback, and synchronize from one screen
NEW FEATURE:  Oni Nonstop Challenge (not finished)
NEW FEATURE:  "Judge Window" option to adjust difficulty of step judging
NEW FEATURE:  Song data cache for faster loading.
NEW FEATURE:  Groove Radar
NEW FEATURE:  Dark Mode (selectable from Player Options screen)
NEW FEATURE (partially complete):  Nonstop Challenge (Oni)
NEW FEATURE (partially complete):  Pump It Up support
NEW FEATURE (partially complete):  Background Animations (defaut animations go in 
     BGAnimations dir)

------------------------Version 2.90-------------------------
CHANGE:  Ogg Vorbis music support re-enabled
NEW FEATURE:  Note Skins (selectable from Player Options screen)

------------------------Version 2.50-------------------------
NEW FEATURE:  New multi game compatible .sm file format.
CHANGE:  "Graphic Detail" presets
BUG FIX:  Installer DirectX check now works
NEW FEATURE:  Aracde and Free Play game modes

------------------------Version 1.90-------------------------
OPTIMIZATION:  Major speedup to BitmapText loading
CHANGE:  Menus changes to accomodate MAX-style menus
CHANGE:  Now compiles in Visual C++.Net
OPTIMIZATION:  Max texture size and texture color options are now supported.
BUG FIX: Scaled sprite alignment (no more transparent strip along the edge of 
     "danger" static)
NEW FEATURE:  Repeating input
NEW FEATURE:  Select Group menu
NEW FEATURE:  Edit / Record / Playback
NEW FEATURE:  Support for DWI solo notes in DWI reader

------------------------Version 1.65-------------------------
BUG FIX:  Statistics now save and load correctly
BUG FIX:  Better framerate during gameplay

------------------------Version 1.64-------------------------
NEW FEATURE:  Group banners on Select Music screen.  Just put a banner in the group 
     folder.
BUG FIX:  Hacked around a Savage texture loading bug.
CHANGE:  Added "hold NEXT for options" after choosing a song.  Most people don't know 
     about this feature!
CHANGE:  Faster song loading
CHANGE:  more accurate synching at song rates other than 100%
CHANGE:  Assist tick calibrated automatically by detecting sound card play latency
CHANGE:  Lowered wait time between menus
CHANGE:  Improved loading time of sounds
BUG FIX:  Improved quality of sounds while dancing
BUG FIX:  Fixed DWI parsing error that often caused the last note to not appear
NEW FEATURE:  More resolution presets in GameOptions menu

------------------------Version 1.63-------------------------
NEW FEATURE:  Effects "drunk", "dizzy", "space"
CHANGE:  Song sort by group now has collapsible sections
BUG FIX:  Prefs, songs, and default mappings now load if StepMania.ini doesn't exist
BUG FIX:  Pad 2 can now be used to navigate the title screen
BUG FIX:  Crash if change sort while a section item was selected
BUG FIX:  BPM changes to 0 when section is selected
BUG FIX:  Pixel/Texel alignment bug causing a strip of color along right and bottom 
     edges moving between menus.
BUG FIX:  Graphical glitches on Results screen
BUG FIX:  Hold Steps now look better when Scroll Speed is > 1
BUG FIX:  Wrong Ghost Arrow graphic being used
BUG FIX:  Boost/Scroll Speed interaction is now like MAX
BUG FIX:  DWI's with newlines before semicolon are no longer corrupt when saving 
     using Synchronize
BUG FIX:  #516498 - Installing Stepmania Deletes records
BUG FIX:  #517003 - Joystick mappings not flushed
BUG FIX:  Multiple NEXT presses not allowed on Caution screen
NEW FEATURE:  Skip Caution toggle
NEW FEATURE:  Announcer toggle
BUG FIX:  Arrows no longer jump back to time = 0 on fail or cleared
BUG FIX:  #523621 - Turning on effects in Double (1.62)
BUG FIX:  #521941 - Using pad to select songs acts weird

------------------------Version 1.62-------------------------
CHANGE:  Can now press NEXT to skip Caution screen.
BUG FIX:  Crash at "No music" prompt.
NEW FEATURE:  Synchronize while dancing with '+', '-', "PgUp", "pgDn"
BUG FIX:  DWI parsing no longer crashes on line with only a space

------------------------Version 1.61-------------------------
BUG FIX:  Players' Best crowns not displaying.
BUG FIX:  #506751 - "Assist" Ticks off-beat
BUG FIX:  Crash switching sort
NEW FEATURE:  Synchronize mode!  Can write BMS and DWI formats.

------------------------Version 1.60-------------------------
BUG FIX:  Inefficient use of memory in Select Music screen
OPTIMIZATION:  No noticable loading time in Select Music
CHANGE:  New grade graphics (thanks Parasyte!)
BUG FIX: 511184 - Battle mode not working
BUG FIX: 510557 - Result *** overlays result letter
BUG FIX: 510556 - Sound stops at Options Screen
BUG FIX: NG percentage is "-1%" if no Hold Steps
BUG FIX: #507861 - Multiple Enter on Song Wheel
BUG FIX: #507391 - Song Options menu fade errors
BUG FIX: #506820 - Select Style Versus Images
BUG FIX: #506746 - Difficulty Mix-Ups in Song Select
BUG FIX: #506597 - Empty Sort Crash
BUG FIX: #511543/#511186 - Visualizations not shown correctly

------------------------Version 1.59-------------------------
NEW FEATURE: More texture loading hints (DITHER, NO_MIP_MAPS) for increased 
     quality and faster loading time.
BUG FIX: #506274 Crash changing song after sorting.
BUG FIX: #506343 TextureColor=32 Auto-Reset
CHANGE: SMLauncher integrated with the main StepMania executable.  Now the 
     pretty error screen will appear automatically.
NEW FEATURE:  Added Low-Medium-High detail prompt to installer.
NEW FEATURE: Song sort order is now rememebered.
OPTIMIZATION:  Instantaneous Song Sort Order switch.
OPTIMIZATION:  Instantaneous Song Group expand/collapse.
CHANGE: Song Sort groups that begin with a number now appear under the "NUM" 
     group.
BUG FIX: "Player's Best" is now sorted by num times played decending
BUG FIX: #506835 - PREV from Song Select Fade Glitch
BUG FIX: #506827 - Song Selected Graphic Errors

------------------------Version 1.58-------------------------
NEW FEATURE: SMLauncher generates friendly error messages.
CHAGNE: Removed "NG" from Results screen.
BUG FIX: Statistics are now working, honest!
BUG FIX: 511544 - Grade Results Sometimes pops up NO DATA
OPTIMIZATION: Improved animation of and optimized drawing of rolling score display.
OPTIMIZATION: Toned down motion blur effect in "Failed" for increased performance.
BUG FIX: Fixed matrix stack bug that caused some shadows not to draw
OPTIMIZATION: Major optimization of BitmapText.  Now about 2x faster.
NEW FEATURE: F4-F8: Toggle Fullscreen, Change Resolution, Change Display Color, 
     Change Texture Color, Toggle Statistics
NEW FEATURE: Remebers last selected Steps
NEW FEATURE: Stage number saved to .ini file.
BUG FIX: Default key buttons don't work if .ini file not present on startup
CHANGE: Hold Arrows are now drawn last to first, like in DDR MAX.
NEW FEATURE: Hold Arrows allow you to not hold the button for a second without 
     NG'ing them.
CHANGE: Regular Arrows on the same line as a Hold Arrow now appear green.
NEW FEATURE: Hold Arrows now turn gray player doesn't hold the button.
BUG FIX: #510980 Danger is a static box, not text

------------------------Version 1.57-------------------------
NEW FEATURE: smzip package installer and manager
CHANGE: Installer now uninstalls previous version.
BUG FIX: Package Manager now converts all non-HTTP-friendly characters to '_' when 
     exporting.
CHANGE: Much better texture loading algorithm.  Texture quality and loading time of 
     non-power of 2 texture improved greatly.
CHANGE: New 5th Mix theme graphics.  Thanks thingmabobr!
BUG FIX: #507170 Speed Problem (Got rid of "pauses" caused by buffered writing to 
     log)
BUG FIX: #506309 Installer doesn't overwrite files
BUG FIX: #511187 old banners are shown diagonal

------------------------Version 1.56-------------------------
BUG FIX: 506314 Fixed "Hall of mirrors" on nVidia cards (actually, just a work 
     around for a driver bug)
CHANGE: Couple and Solo now appear in Select Style
CHANGE: New Title Menu options (but you can choose them yet :-)
BUG FIX: Fixed jibberish at the top of Arial Bold font by shifting all letters 
     up one pixel
BUG FIX: 505896 Menu Problems [unreadable/illegible font?]
BUG FIX: Ugly textures with Voodoo3
BUG FIX: Ignore Joystick D-pad now works again.
BUG FIX: Installer-created icon "Open Songs Folder" now fixed for OSes that had 
     problems.
BUG FIX: BMS parse crash fixed.
BUG FIX: Player2 couldn't press up to select different steps
BUG FIX: Player2's side in StepsSelector no longer has multiple bouncing difficulty 
     icons
BUG FIX: 507380 Multiple FAILED with Esc presses
BUG FIX: 507860 - Esc in No Fail Mode = lock up
CHANGE: Improved response time to user input when change sort in SelectMusic
BUG FIX: Announcer no longer makes dancing comments while FAILED is showing.
OPTIMIZATION: Added texture alpha hints - significantly improved texture quality 
     for 16-bit textures.

------------------------Version 1.55-------------------------
BUG FIX: "4nd Stage" is now "4th Stage"
BUG FIX: 496315 ragescreen.cpp error for 16bit-only cards
BUG FIX: 500342 - wave volume changes to 100% on startup
BUG FIX: Fixed "visualization movie files go here" trying to be loaded as a texture
BUG FIX: Mini banner now tweens on and off screen
BUG FIX: MusicWheel now tweens off screen and Music comment plays
BUG FIX: Stage count not incremented until song is passed
CHANGE: Added longer delay before song start
CHANGE: Assist tick now louder and timing improved
CHANGE: cleaned up debug messages
OPTIMIZATION: Improved texture loading time
CHANGE: Maximize button no longer toggles fullscreen.
CHANGE: MusicWheel response to user input is improved
OPTIMIZATION: Preview in SelectMusic now uses banner instead of background for faster 
     loading
NEW FEATURE: Change resolution, display color depth, texture color depth, and toggle 
     texture filtering
NEW FEATURE: Check at startup time that all required theme elements are present
NEW FEATURE: installer
NEW FEATURE: motion blur "Failed" effect
NEW FEATURE: MusicWheel remembers previously selected song.
BUG FIX: Back from Result screen no longer leads to black screen
CHANGE: All documentation is now in "Docs" folder
CHANGE: New "Danger" animation

------------------------Version 1.50-------------------------
Bug fix: No longer crashes on foreign chars in BMS files. Please report all songs that 
     still cause a crash. 
Change: Added sepatate background movie property to Song. Now status backgrounds will 
     display in SelectMusic if the Song has a movie background. 
Change: Asset directory structure has completely changed in preparation for theme support. 
Optimization: BitmapText is now ~80% faster. 
New Feature: 5th Mix style SelectMusic and auto-generated text banners. Loads 100x faster 
     than the previous SelectSong screen. 
Change: Error messages in Release builds no longer show source file line and number. 
Bug Fix: Fade transition now fades all the way to black (doesn't leave a "hazy" screen). 
Bug Fix: Multiple joysticks now work again. 

-------------------------Version 0.97-------------------------
Bug fix: Songs with same title no longer change positions while scrolling.
Bug fix: Wrong group name for DWI files in the Songs folder.
Bug fix: Fixed a problem that caused the music to become out of sync if many sound 
     effect are played.  This was causing the song to become out of sync near the end.  
     Note that this change makes the music much more accurate, and some BMS files may 
     be out of sync if they appeared in sync before.
Bug fix: Dancing waits 2 seconds before starting music playback.  This allows some 
     slower systems to catch up.
Bug fix: Little now works correctly.  It is accessible from the PlayerOptions menu.
Optimization: Lower priority for movie decoding, which is a major speed boost on 
     slower computers.
Change: Freeze arrow scoring now matches DDR MAX.  The start of a freeze arrow is judged 
     as other steps are (perfect, great, good, etc).  Missing the start of a freeze will 
     should break your combo, but NG'ing the freeze arrow will not. 
New feature: Basic song statistics tracking.  Times played, top score, top combo, and 
     top grade are shown on SelectSong screen.
New feature: Assist tick, accessible from the SongOptions menu. 
New feature: Music Rate, accessible from the SongOptions menu.  You can speed up or 
     slow down the rate of music playback.  Great for practicing hard step patterns.
New feature: Freeze arrow scores are now shown on the Results screen.
Change: Arrow ghost now appear different depending on the combo length (roughly matches 
     DDR MAX).
Change: Added some animation to the Results screen.
Change: Revamped input mapping to allow assignment and clearing of specific slots.

-------------------------Version 0.96b-------------------------
Change: Removed background movies showing in SelectSong (this was causing crashes).
Bug fix: No longer crashes when loading Max300 from DWI support directory.
Bug fix: Timing is now correct for freeze in Max300.
Bug fix: Freeze arrows now are correct in Mirror/Left/Right/Shuffle.

-------------------------Version 0.96-------------------------
Merry Christmas!
Changed the song directory structure to be backward compatible with 0.90 and 0.91.

-------------------------Version 0.95-------------------------
Bug fix: Sounds files with commas now load
Bug fix: Freezes in Telephone Operator are now correct
Bug fix: Nonsense help messages fixed
Bug fix: D3D init failure now opens browser to correct troubleshooting page
Optimization:  Drawing of freeze arrows is much more efficient
Optimization:  In SelectSong, only one preview graphic is drawn.  This saves fill rate 
     and leaves room for group/sort/BPM text.
Change: DWI files now use the DWI directory structure.  StepMania also automatically 
     crop and rotate the song banner.  BMS files still reside in the Songs folder.
Change: Now hold Next to get to PlayerOptions and SongOptions menus  (Previously, you 
     would hold Next to bypass these menus).
New feautre: FPS counter.  Can toggle from GameOptions.
New feature: Disable joystick d-pad (for DirectPad Pro and NTPad).
New Feature: Song background movies
New Feature: random visualization movies
New feature: song groups by folder
New feature: song sorting by Title, BPM, and Artist
New: Caution screen to hide texture load time
New: Logo appears between screens as a keepalive indicator

-------------------------Version 0.91-------------------------
Bug fix: Good and Boo arrows not being drawn.


-------------------------Version 0.90-------------------------


-------------------------Version 0.50-------------------------


